package org.aleabodo.fireworksmc.Commands;

import org.aleabodo.fireworksmc.Direction;
import org.aleabodo.fireworksmc.Fireworks_Mc;
import org.aleabodo.fireworksmc.Message;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;

public class Fireworkshow implements CommandExecutor, TabCompleter {
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (!(sender instanceof Player)) {
            sender.sendMessage("This command is reserved for players only!");
            return false;
        }

        Player player = ((Player) sender).getPlayer();

        switch (args[0]) {
            case "setlocation":
                //Set location
                Fireworks_Mc.show.setLocation(player.getLocation());
                Message.sendInfo(player, "Location successfully set to your position.");
                break;
            case "setdirection":
                //Set direction
                switch (args[1]) {
                    case "north":
                        Fireworks_Mc.show.setDirection(Direction.NORTH);
                        break;
                    case "east":
                        Fireworks_Mc.show.setDirection(Direction.EAST);
                        break;
                    case "south":
                        Fireworks_Mc.show.setDirection(Direction.SOUTH);
                        break;
                    case "west":
                        Fireworks_Mc.show.setDirection(Direction.WEST);
                        break;
                    default:
                        Message.sendWarning(player, "Please enter either 'north', 'east', 'south', or 'west'!");
                }
                break;
            case "setduration":
                //Set duration
                try {
                    int duration = Integer.parseInt(args[1]);
                    Fireworks_Mc.show.setDuration(duration);
                    Message.sendInfo(player, "Duration successfully set to " + duration);
                    return true;
                } catch (NumberFormatException e) {
                    Message.sendWarning(player, "Please enter an integer for the duration (in seconds)!");
                }
            case "setseed":
                //Set seed
                StringBuilder result = new StringBuilder(args[1]);
                for (int i = 1; i<args.length; i++) {
                    result.append(" ").append(args[i]);
                }
                Fireworks_Mc.show.setSeed(String.valueOf(result));
                Message.sendInfo(player, "Seed successfully changed to '" + result + "'");
                return true;
            case "start":
                Fireworks_Mc.show.start();
            default:
                Message.sendWarning(player, "Invalid command!");
        }

        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command,
                                                @NotNull String label, @NotNull String[] args) {
        List<String> completions = new ArrayList<>();

        if (args.length == 1) {
            completions.add("setlocation");
            completions.add("setdirection");
            completions.add("setduration");
            completions.add("setseed");
            completions.add("start");
        } else if (args.length == 2 && args[0].equals("setdirection")) {
            completions.add("north");
            completions.add("east");
            completions.add("south");
            completions.add("west");
        }

        return completions;
    }
}
